#include "post.h"
#include "parse.h"
#include "cgi.h"
#include "ieee.h"
#include <string.h>

char* generate_list_inventory() ;
static char *list_value;

/* This program parses bml files
 * 
 */

 void print_help(){
	printf("Command Summary:\n");
	printf(" help - prints help\n");
	printf(" insert key_pairs\n");
	printf("    type of insert figured out based on key pairs given\n");
	printf(" update key_pairs\n");
	printf("    updates table person with values from key pairs\n");
	printf(" view order order=number\n");
	printf(" total inv type=x sub_type=y color=z size=w\n");
	printf(" view expense \n");
	printf(" echo stuff\n");
	printf("   copies stuff to stdout\n");
	printf(" gen list key_pairs\n");
	printf("   generates a html list based on key pairs\n");
	printf(" if =var <command>\n");
	printf(" parse file=bml_file <keypairs>\n");
	printf("   passes the given file through the bml parser");
	printf(" remove key_pairs\n");
	printf(" quit - quits\n");
	printf("Note:    Key_pairs is in the form of field1=val1 field2=val2 ...\n");
	printf("Example: insert inventory=1 type=tshirt color=red price=12.22\n");
 }


 /* Append and parse are intended to be used together. They parse
  *  key=value pairs and construct a QUERY_STRING from it
  */

 void append(char* append_string) {
	char buf[1024];
	if ( getenv ("QUERY_STRING") ) {
		strncpy(buf, getenv("QUERY_STRING"), 1023);
		strncat(buf, "&", 1024-strlen(buf));
		strncat(buf, append_string, 1024-strlen(buf));
		buf[1023]=0;
		setenv ("QUERY_STRING", buf, 1);
	} else
		setenv ("QUERY_STRING", append_string, 1);

 }

void parse(char* buf) {
	char *str1, *str2;
	str1=str2=buf;
	while (str2) {
		str1=strsep(&str2, " ");
		if (*str1) 
			append(str1);
	}

	/*printf("Query String = '%s'\n",getenv("QUERY_STRING"));*/


}

/*
 * Strips the dot from a string in the form of $'xxxx.xx'
 *  gets string from keypairs using cgi library where
 *  key=variable_name
 */
int strip_dot(char* variable_name) {
	char  *str1, *str2;
	str2=get_data(variable_name);
	if (str2) { /* strips dot from $xxxxx.xx */
		str1=strsep(&str2, ".");
		strncat(str1, str2, 10);
		return atoi(str1);
	}
	return 0;
}

/*
 * The fill_* functions fill their respective structs with data from
 *            the QUERY_STRING environment variable (or POST).
 *
 *  fill_receipt - also associates a order_form with a list of receipts
 */
inventory_type* fill_inventory() {
	static inventory_type inventory;
	inventory.type=get_data("type");
	inventory.sub_type=get_data("sub_type");
	inventory.size=get_data("size");
	inventory.color=get_data("color");
	inventory.description=get_data("description");
	if (get_data("who"))
		inventory.who=atoi(get_data("who"));
	else
		inventory.who=0;

	inventory.price=strip_dot("price");

	if (get_data("stock") )
		inventory.stock=atoi(get_data("stock"));
	else
		inventory.stock=0;

	return &inventory;
}

void fill_expense() {
	expense_type expense;

	if (!get_data("person")) {
		printf("Error: Expense insertion requires a person to be\n");
		printf("       associated with the expense.\n\n");
		return;
	}
	if (!get_data("amount")) {
		printf("Error: Expense insertion requires amount be specified\n");
		return;
	}

	expense.account=get_data("account");
	expense.amount=strip_dot("amount");
	expense.description=get_data("description");
	insert_expense(&expense, atoi(get_data("who")));
}

char* create_order_num() {
	PGresult *res;
	static char* order=0;
	if (order) return order;

	/* Note: a receipt item can be attached to a order after a order has
	 *       been completed. This should be prevented through the use of
	 *       triggers.
	 */

	 /*
	  * We should select our order_form based on oid, not...
	  */

	if (!get_data("order_num") || !*(get_data("order_num")) || *(get_data("order_num")) == '0'){
		exec("insert into order_form (ds) values ('now')");
		if (PQntuples(res=exec(
"select order_num from order_form where ds=(select max(ds) from order_form)")))
			return order=PQgetvalue(res,0,0);
		else {
			printf("Error: Could not obtain a order_form number");
			return 0;
		}

	}
	return order=get_data("order_num");

}

void fill_receipt() {
	receipt_type receipt;
	PGresult *res;
	const char order_string[]={"item_num"};
	int order, inventory;


	order=atoi(create_order_num());
	if (!order) {
		printf("Error 239: order null\n");
		return ;
	}


	if (!get_data("inventory")) {
		if (get_data("type")&&get_data("sub_type")&&get_data("size")
		  &&get_data("color")) {

		 list_value=(char*)order_string;

		if(PQntuples(res=exec(generate_list_inventory()))) 
			inventory=atoi(PQgetvalue(res,0,0));
		else {
			printf("Error: could not find a inventory item associated with\n");
			printf("       the associated stock... possibly the item is   \n");
			printf("       out of stock???\n\n");
			return ;
		}


		}
		else {
			printf("Error: Receipt insertion requires a associated inventory\n");
			return ;
		} 
	}

	if (get_data("tax")) 
		receipt.tax=atoi(get_data("tax"));
	else
		receipt.tax=0;

	receipt.price=strip_dot("price");
	receipt.description=get_data("description");
	receipt.account=get_data("account");
	insert_receipt(&receipt, order, inventory);
}

persocom* fill_person() {
	static persocom person;
	if (get_data("ieee_number"))
		person.ieee_number=atoi(get_data("ieee_number"));
	else
		person.ieee_number=0;

	if (get_data("zip"))
		person.zip=atoi(get_data("zip"));
	else
		person.zip=0;

	if (get_data("phone"))
		person.phone=atoi(get_data("phone"));
	else
		person.phone=0;

	if (get_data("serial"))
		person.serial=atoi(get_data("serial"));
	else
		person.serial=0;

	person.url=get_data("url");
	person.real_name=get_data("real_name");
	person.user_name=get_data("user_name");
	person.password=get_data("password");
	person.email=get_data("email");
	person.street=get_data("street");
	person.city=get_data("city");
	person.description=get_data("description");

	return &person;

}

void link_order_form(PGresult *res) {
	char buf[2048];
	sprintf(buf, "select who from person where oid=%d", PQoidValue(res));
	res=exec(buf);
	printf("<P>Person Number: %s</P>", PQgetvalue(res,0,0));
	sprintf(buf,"update order_form set who=%s where order_num=%s", PQgetvalue(res,0,0), get_data("order_num"));
	exec(buf);
}

/* insert() checks QUERY_STRING for certain variables
 *    if they exist it calls other functions which 
 *    will attempt to add the anticapated data into
 *    their database.
 */   
void insert() {
	PGresult *res;
	if (get_data("inventory")) 
		insert_inventory(fill_inventory());
	else if (get_data("expense")) 
		fill_expense();
	else if (get_data("receipt")) 
		fill_receipt();
	else if (get_data("person")) {
		res=insert_person(fill_person());
		if (get_data("order_num"))
			link_order_form(res);
	}
	else
		printf("Please specify a table to insert into\n");
}

void remove_row() {
	char buf[5027];
	PGresult *res;
	if (get_data("receipt")) {
		if (get_data("item_num") && *(get_data("item_num")) &&
		    get_data("order_num") && *(get_data("order_num"))) {
			sprintf(buf, 
				"delete from receipt where order_num=%s and item_num=%s",
				get_data("order_num"), get_data("item_num"));
			res=exec(buf);
		   	printf("<H2>%s items removed</H2>\n",PQcmdTuples(res));
		}


	} else
		printf("Deletion requested, but no target given for deletion");
}

/*
 * From the CS180 example code
 */
void pretty_print(PGresult *res) {
	PQprintOpt print_opts;

	memset( &print_opts, '\0', sizeof( print_opts ));
	print_opts.header = 1;
	print_opts.align = 1;
	print_opts.html3 = 0;
	print_opts.fieldSep = "|";
	PQprint( stdout, res, &print_opts );

}

void print_order_html() {
	PGresult *res;
	while ( PQntuples(res=exec("fetch forward from csor")) ) {
		printf("<TR><TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD><A HREF=\"%s?file=%s&order_num=%s&item_num=%s&remove=1&type=%s&sub_type=%s&size=%s&color=%s&cat=meow\">Remove</A><TD ALIGN=\"right\">%s\n",
		  PQgetvalue(res,0,0),
		  PQgetvalue(res,0,1),
		  PQgetvalue(res,0,2),
		  PQgetvalue(res,0,3),
		  PQgetvalue(res,0,4),
		  get_data("parse"), get_data("file"), get_data("order_num"), PQgetvalue(res,0,5), get_data("type"), get_data("sub_type"), get_data("size"), get_data("color"),
		  PQgetvalue(res,0,6)
		  );
	}
}



/* Prints out a HTML table containing the items in 
 *  the order form structure
 */

void view_order() {
	char buf[1024];
	PGresult *res;

	if (!get_data("order_num")) {
		printf("Error: Missing serial for orderform query");
		return;
	}

	exec("begin transaction");

	sprintf(buf, "declare csor cursor for select count(receipt.receipt_num), inventory.type, inventory.sub_type, inventory.size, inventory.color, inventory.item_num, receipt.price from inventory, receipt where receipt.order_num=%s and receipt.item_num=inventory.item_num group by inventory.item_num, type, sub_type, size, color, price order  by type, sub_type, size, color ",
		get_data("order_num"));
	exec(buf);
	print_order_html();
	sprintf(buf, "select sum(receipt.price) from inventory, receipt where receipt.order_num=%s and receipt.item_num=inventory.item_num",
		get_data("order_num"));
	printf("<TR><TD>&nbsp;<TR><TD COLSPAN=6>&nbsp;<TD BGCOLOR=\"#EEEEEE\" ALIGN=\"right\"> %s\n\n",PQgetvalue(res=exec(buf),0,0));

	exec("close csor");
	exec("end transaction");

}

void total_inventory(char *type, char *sub_type, char* size, char* color) {
	char buf[1024];
	sprintf(buf, "select count (*) as total from receipt where item_num IN (select item_num from inventory where type='%s' and sub_type='%s' and size='%s' and color='%s') AND (select count (*) from order_form where paid=1 AND order_num=receipt.order_num) > 0",
		type, sub_type, size, color);
	pretty_print(exec(buf));
}

void total_inv() {
	total_inventory(get_data("type"), get_data("sub_type"), get_data("size"),
					get_data("color"));
}

void view_expense() {
	char buf[1024];
	sprintf(buf, "select amount, account, who, ds from expense");
	pretty_print(exec(buf));
}


/* generate_list_inventory generate a select statement where 
 * list variable indicates the values to be returned, and 
 * the constraints (where clause) are the variables type,
 * sub_type, color, and size as well as having a total > 0
 *
 * Note: it was intended to take as input a struct inventory...
 *       but somehow it was programmed using get_data() routines
 */
char* generate_list_inventory() {
	static char buf[1024];
	char append[256];
	int and=0;
	if (!get_data("list_value") && !list_value ) {
		printf("Error list_value environment variable is not present\n");
		return 0;
	} ;

	if (list_value) {
		sprintf(buf, "select distinct %s from inventory_in_stock ", list_value);
		list_value=0;
	}
	else
		sprintf(buf, "select distinct %s from inventory_in_stock ", get_data("list_value"));

	if (get_data("type")) {
		sprintf(append,"%s type='%s'",!and?"where":"", get_data("type"));
		strcat(buf,append);
		and=1;
	}
	if (get_data("sub_type")) {
		if (and)
			strcat(buf, "AND ");
		sprintf(append,"%s sub_type='%s'",!and?"where":"", get_data("sub_type"));
		and=1;
		strcat(buf,append);
	}
	if (get_data("color")) {
		if (and)
			strcat(buf, "AND ");
		sprintf(append,"%s color='%s'",!and?"where":"", get_data("color"));
		and=1;
		strcat(buf,append);
	}
	if (get_data("size")) {
		if (and)
			strcat(buf, "AND ");
		sprintf(append,"%s size='%s'",!and?"where":"", get_data("size"));
		and=1;
		strcat(buf,append);
	}

	/* where total > xxx */

	return buf;

}

void option_list() {
	PGresult *res;
	char *fetch_data, *env_data;
	int i=0;

	if (get_data("list_old") && *get_data("list_old"))
		printf("\t<OPTION VALUE=\"%s\">%s\n",get_data("list_old"),
											 get_data("list_old"));
	if (get_data("list_new"))
		printf("\t<OPTION VALUE=\"%s\">%s\n",get_data("list_new"),
											 get_data("list_new"));

	
	while ( PQntuples(res=exec("fetch forward from csor")) ) {
		fetch_data=PQgetvalue(res,0,0);

		if ( !i ) {
			i=1;
			env_data=get_data("list_default");
			if (!env_data || !(*env_data))
				printf("\t<OPTION SELECTED VALUE=\"\">\n");
		}

		if ( env_data && !strcasecmp(env_data, fetch_data) )
			printf("\t<OPTION SELECTED VALUE=\"%s\">%s\n",fetch_data, fetch_data);
		else
			printf("\t<OPTION VALUE=\"%s\">%s\n",fetch_data, fetch_data);
												 
	}
	exec("close csor");
}

void image_list() {
	PGresult *res;
	while ( PQntuples(res=exec("fetch forward from csor")) ) 
		printf("<A HREF=\"%s?order_num=%s&parse=%s&file=%s&%s=%s\"><IMG SRC=\"%s.jpg\" ALT=\"%s\">&nbsp</A>",
			    get_data("parse"), create_order_num(), get_data("parse"), get_data("file"), PQfname(res,0), 
				PQgetvalue(res,0,0), PQgetvalue(res,0,0), PQgetvalue(res,0,0));
}

/* executes query string and stores the result into a cursor.
 *  once the result is stored, it looks at the value of list_query
 *  to determine how to display the data, and then calls the appropriate
 *  function to iterate through the cursor. after the function has
 *  completed, it finishes the transaction.
 */
void cursor_itor(char *query_string) {
	char buf[1024];
	if (!query_string || strlen(query_string) < 10 || strlen(query_string) > 950) {
		if (!query_string)
			printf("Query string is null\n\n");
		else
			printf("Quersy string '%s' fails bounds checking\n\n", query_string);
		return ;
	}
	exec("begin transaction");
	sprintf(buf,"declare csor cursor for %s", query_string);
	exec(buf);
	if (get_data("list_query")) {
		if (!strncasecmp(get_data("list_query"), "option", 6)) 
			option_list();
		else if (!strncasecmp(get_data("list_query"), "image", 5)) 
			image_list();
		else {
			printf("Unknown list type '%s',\n",get_data("list_query"));
			printf("known types = option, image\n\n");
		}


	} else
		printf("list_query environment variable not present\n\n");
	exec("end transaction");
}


/*
 * generate list from table, currently only inventory type is supported.
 *
 * ex. gen list inventory=1 list_value=color list_query=option type=1
 */
void generate_list() {
	if (get_data("inventory")) 
		cursor_itor(generate_list_inventory(fill_inventory()));
	else
		printf("unknown table type\n");

}

void do_command(char* cmd_ptr) {
	char meow[256];
	char **bml_list;

	if (!cmd_ptr)
		return;

	while (*cmd_ptr && (*cmd_ptr==' '))
		cmd_ptr++;


	if ( strncasecmp(cmd_ptr, "help", 4) == 0 )
		print_help(); 

	else if ( strncasecmp(cmd_ptr, "insert", 6) == 0 ) {
		cmd_ptr=cmd_ptr+6;
		(char*)cmd_ptr=strsep(&cmd_ptr, "\n");
		parse(cmd_ptr);
		insert();
	} 
	else if ( strncasecmp(cmd_ptr, "update", 6) == 0 ) {
		cmd_ptr=cmd_ptr+6;
		(char*)cmd_ptr=strsep(&cmd_ptr, "\n");
		parse(cmd_ptr);
		update_person(fill_person());
	} 
	else if (strncasecmp(cmd_ptr, "view order", 10) == 0 ) {
		cmd_ptr=cmd_ptr+10;
		(char*)cmd_ptr=strsep(&cmd_ptr, "\n");
		parse(cmd_ptr);
		view_order();
	}
	else if (strncasecmp(cmd_ptr, "total inv ", 10) == 0 ) {
		cmd_ptr=cmd_ptr+10;
		(char*)cmd_ptr=strsep(&cmd_ptr, "\n");
		parse(cmd_ptr);
		total_inv();
	}
	else if (strncasecmp(cmd_ptr, "view expense", 12) == 0 ) {
		cmd_ptr=cmd_ptr+12;
		(char*)cmd_ptr=strsep(&cmd_ptr, "\n");
		parse(cmd_ptr);
		view_expense();
	}
	else if (strncasecmp(cmd_ptr, "echo", 4) == 0 ) {
		cmd_ptr=cmd_ptr+4;
		printf("%s",cmd_ptr);
	}
	/* 
	 * 'if' checks for the existance of a value after the conditional
	 * for instance if foo=blah, the conditional is true, but if
	 * foo= , the conditional is false. In this fashion, testing
	 * foo=%replaced_value% tests to see if %replaced_value% exists
	 *
	 * if the conditional is true, the contents after the conditional
	 * are reinterpreted. (womewhat like c's if (a) do_blah;)
	 */
	else if (strncasecmp(cmd_ptr, "if", 2) == 0 ) {
		cmd_ptr=cmd_ptr+2;
		cmd_ptr=strstr(cmd_ptr,"=");
		if (cmd_ptr && *(cmd_ptr+1) && ((*(cmd_ptr+1)!=' ') && *(cmd_ptr+1)!='0'))
			do_command(strstr(cmd_ptr," "));
	}
	else if (strncasecmp(cmd_ptr, "gen list", 8) == 0 ) {
		cmd_ptr=cmd_ptr+8;
		parse(cmd_ptr);
		generate_list(); }
	else if (strncasecmp(cmd_ptr, "remove", 6) == 0 ) {
		cmd_ptr=cmd_ptr+6;
		parse(cmd_ptr);
		remove_row();
	}
	else if (strncasecmp(cmd_ptr, "parse", 5) == 0 ) {
		cmd_ptr=cmd_ptr+5;
		parse(cmd_ptr);
		bml_list=parse_bml(get_data("parse_file"));
		while (bml_list && *bml_list) {
			setenv ("RESTART", "YES", 1);
			unsetenv ("QUERY_STRING");
			printf("%s",*bml_list++);
			do_command(*bml_list++);
		}
	} else if ( strncasecmp(cmd_ptr, "quit", 4) == 0)
		return ; else
	printf("Invalid Command '%s'\n\n", cmd_ptr);
}

int main() {
	char **bml_list=0;

	if (get_data("file"))
		bml_list=parse_bml(get_data("file"));
	setenv("NO_HEADERS", "TRUE", 1);

	while (bml_list && *bml_list) {
		setenv ("RESTART", "YES", 1);
		unsetenv ("QUERY_STRING");
		printf("%s",*bml_list++);
		do_command(*bml_list++);
	}

	return(0);
}
